'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _maxSafeInteger = require('babel-runtime/core-js/number/max-safe-integer');

var _maxSafeInteger2 = _interopRequireDefault(_maxSafeInteger);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _WheelHandler = require('./dom/WheelHandler');

var _WheelHandler2 = _interopRequireDefault(_WheelHandler);

var _TouchHandler = require('./dom/TouchHandler');

var _TouchHandler2 = _interopRequireDefault(_TouchHandler);

var _Scrollbar = require('./Scrollbar');

var _Scrollbar2 = _interopRequireDefault(_Scrollbar);

var _FlexiGridVerticalScrollHelper = require('./FlexiGridVerticalScrollHelper');

var _FlexiGridVerticalScrollHelper2 = _interopRequireDefault(_FlexiGridVerticalScrollHelper);

var _FlexiGridHorizontalScrollHelper = require('./FlexiGridHorizontalScrollHelper');

var _FlexiGridHorizontalScrollHelper2 = _interopRequireDefault(_FlexiGridHorizontalScrollHelper);

var _FlexiGridColumnBuffer = require('./FlexiGridColumnBuffer');

var _FlexiGridColumnBuffer2 = _interopRequireDefault(_FlexiGridColumnBuffer);

var _FlexiGridHeader = require('./FlexiGridHeader');

var _FlexiGridHeader2 = _interopRequireDefault(_FlexiGridHeader);

var _FlexiGridBody = require('./FlexiGridBody');

var _FlexiGridBody2 = _interopRequireDefault(_FlexiGridBody);

var _FlexiGridShadowTop = require('./FlexiGridShadowTop');

var _FlexiGridShadowTop2 = _interopRequireDefault(_FlexiGridShadowTop);

var _FlexiGridShadowLeft = require('./FlexiGridShadowLeft');

var _FlexiGridShadowLeft2 = _interopRequireDefault(_FlexiGridShadowLeft);

var _FlexiGridShadowRight = require('./FlexiGridShadowRight');

var _FlexiGridShadowRight2 = _interopRequireDefault(_FlexiGridShadowRight);

var _FlexiGridShadowBottom = require('./FlexiGridShadowBottom');

var _FlexiGridShadowBottom2 = _interopRequireDefault(_FlexiGridShadowBottom);

var _FlexiGridColumnResizeKnobs = require('./FlexiGridColumnResizeKnobs');

var _FlexiGridColumnResizeKnobs2 = _interopRequireDefault(_FlexiGridColumnResizeKnobs);

var _FlexiGridColumnReorderKnobs = require('./FlexiGridColumnReorderKnobs');

var _FlexiGridColumnReorderKnobs2 = _interopRequireDefault(_FlexiGridColumnReorderKnobs);

var _FlexiGridColumnResizeHandler = require('./FlexiGridColumnResizeHandler');

var _FlexiGridColumnResizeHandler2 = _interopRequireDefault(_FlexiGridColumnResizeHandler);

var _FlexiGridColumnReorderHandler = require('./FlexiGridColumnReorderHandler');

var _FlexiGridColumnReorderHandler2 = _interopRequireDefault(_FlexiGridColumnReorderHandler);

var _utils = require('./utils');

var _FlexiGridColumnHelper = require('./FlexiGridColumnHelper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGrid = function (_React$Component) {
  (0, _inherits3.default)(FlexiGrid, _React$Component);

  function FlexiGrid() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FlexiGrid);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FlexiGrid.__proto__ || (0, _getPrototypeOf2.default)(FlexiGrid)).call.apply(_ref, [this].concat(args))), _this), _this.onScroll = function (deltaX, deltaY) {
      if (!_this.scrolling) {
        _this.didScrollStart();
      }

      if (Math.abs(deltaY) > Math.abs(deltaX) && _this.state.showScrollbarY) {
        _this.doVerticalScroll(deltaY, true);
      } else if (deltaX && _this.state.showScrollbarX) {
        _this.doHorizontalScroll(deltaX, true);
      }

      _this.didScrollStop();
    }, _this.onHorizontalScroll = function (scrollX) {
      if (scrollX === _this.state.scrollX) {
        return;
      }

      if (!_this.scrolling) {
        _this.didScrollStart();
      }

      _this.doHorizontalScroll(scrollX, false);
      _this.didScrollStop();
    }, _this.onVerticalScroll = function (scrollY) {
      if (scrollY === _this.state.scrollY) {
        return;
      }

      if (!_this.scrolling) {
        _this.didScrollStart();
      }

      _this.doVerticalScroll(scrollY, false);
      _this.didScrollStop();
    }, _this.shouldHandleWheelX = function (delta) {
      if (!_this.state.showScrollbarX || delta === 0) {
        return false;
      }

      delta = Math.round(delta); // eslint-disable-line
      if (delta === 0) {
        return false;
      }

      return delta < 0 && _this.state.scrollX > 0 || delta >= 0 && _this.state.scrollX < _this.state.maxScrollX;
    }, _this.shouldHandleWheelY = function (delta) {
      if (!_this.state.showScrollbarY || delta === 0) {
        return false;
      }

      delta = Math.round(delta); // eslint-disable-line
      if (delta === 0) {
        return false;
      }

      return delta < 0 && _this.state.scrollY > 0 || delta >= 0 && _this.state.scrollY < _this.state.maxScrollY;
    }, _this.shouldHandleTouchX = function (delta) {
      return _this.props.touchScrollEnabled && _this.shouldHandleWheelX(delta);
    }, _this.shouldHandleTouchY = function (delta) {
      return _this.props.touchScrollEnabled && _this.shouldHandleWheelY(delta);
    }, _this.onColumnResize = function (_ref2, e) {
      var column = _ref2.column,
          knobSize = _ref2.knobSize,
          left = _ref2.left,
          top = _ref2.top,
          rtl = _ref2.rtl,
          adjustKnob = _ref2.adjustKnob;
      var _this$state = _this.state,
          headerHeight = _this$state.headerHeight,
          bodyHeight = _this$state.bodyHeight;

      _this.columnResizingData = {
        prefixCls: _this.props.prefixCls,
        rtl: rtl,
        offsetLeft: left,
        offsetTop: top,
        knobSize: knobSize,
        adjustKnob: adjustKnob,
        initialWidth: column.width,
        height: headerHeight + bodyHeight,
        minWidth: column.minWidth || 0,
        maxWidth: column.maxWidth || _maxSafeInteger2.default,
        columnKey: column.key,
        initialEvent: {
          clientX: e.clientX,
          clientY: e.clientY,
          preventDefault: function preventDefault() {}
        },
        onColumnResizing: _this.onColumnResizing,
        onColumnResized: _this.onColumnResized
      };

      if (_this.props.onColumnResize) {
        _this.props.onColumnResize(column.key, column.width);
      }

      _this.setNextState({ columnResizingKey: column.key });
    }, _this.onColumnResizing = function (columnWidth, columnKey) {
      if (_this.props.onColumnResizing) {
        _this.props.onColumnResizing(columnKey, columnWidth);
      }
    }, _this.onColumnResized = function (columnWidth, columnKey) {
      if (_this.props.onColumnResized) {
        _this.props.onColumnResized(columnKey, columnWidth);
      }

      if (!_this.columnWidthMap) {
        _this.columnWidthMap = {};
      }

      _this.columnWidthMap[columnKey] = columnWidth;
      _this.columnResizingData = null;

      _this.setNextState((0, _extends3.default)({}, _this.calculateState(_this.props, _this.state), {
        columnResizingKey: null
      }));
    }, _this.onColumnReorder = function (_ref3, e) {
      var column = _ref3.column;

      _this.columnReorderingData = {
        column: column,
        initialEvent: {
          clientX: e.clientX,
          clientY: e.clientY,
          preventDefault: function preventDefault() {}
        },
        onColumnReordering: _this.onColumnReordering,
        onColumnReordered: _this.onColumnReordered
      };

      if (_this.props.onColumnReorder) {
        _this.props.onColumnReorder(column.key);
      }

      _this.setNextState({ columnReorderingKey: column.key });
    }, _this.onColumnReordering = function (_ref4) {
      var targetKey = _ref4.targetKey,
          movingLeft = _ref4.movingLeft,
          position = _ref4.position;
      var column = _this.columnReorderingData.column;

      if (!column.fixed) {
        var _this$props = _this.props,
            dragScrollSpeed = _this$props.dragScrollSpeed,
            dragScrollBuffer = _this$props.dragScrollBuffer;
        var _this$state2 = _this.state,
            bodyWidth = _this$state2.bodyWidth,
            scrollX = _this$state2.scrollX,
            maxScrollX = _this$state2.maxScrollX,
            columnData = _this$state2.columnData;
        var leftFixedColumns = columnData.leftFixedColumns,
            rightFixedColumns = columnData.rightFixedColumns;

        // auto scroll on moving

        var scrollTo = scrollX;
        if (movingLeft) {
          if (scrollX > 0 && position < (0, _FlexiGridColumnHelper.getColumnsWidth)(leftFixedColumns) + dragScrollBuffer) {
            scrollTo = Math.max(scrollX - dragScrollSpeed, 0);
          }
        } else if (scrollX < maxScrollX && position + column.width > bodyWidth - (0, _FlexiGridColumnHelper.getColumnsWidth)(rightFixedColumns) - dragScrollBuffer) {
          scrollTo = Math.min(scrollX + dragScrollSpeed, maxScrollX);
        }

        if (scrollTo !== scrollX) {
          _this.doHorizontalScroll(scrollTo, false);
        }
      }

      if (_this.props.onColumnReordering) {
        _this.props.onColumnReordering(column.key, targetKey);
      }
    }, _this.onColumnReordered = function (targetColumnKey) {
      if (!_this.columnOrderMap) {
        _this.columnOrderMap = {};
      }

      var column = _this.columnReorderingData.column;

      var siblings = _this.getColumnSiblings(column);
      var sourceColumnKey = column.key;

      siblings.forEach(function (_ref5, index) {
        var key = _ref5.key;

        if (key === targetColumnKey) {
          _this.columnOrderMap[sourceColumnKey] = index;
        } else if (key === sourceColumnKey) {
          _this.columnOrderMap[targetColumnKey] = index;
        }
      });

      if (_this.props.onColumnReordered) {
        _this.props.onColumnReordered(sourceColumnKey, targetColumnKey);
      }

      if (_this.props.onHorizontalScroll && _this.columnReorderingData.scrollX !== _this.state.scrollX) {
        _this.props.onHorizontalScroll(_this.state.scrollX);
      }

      _this.setNextState((0, _extends3.default)({}, _this.calculateState(_this.props, _this.state), {
        columnReorderingKey: null
      }));

      _this.columnReorderingData = null;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(FlexiGrid, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.didScrollStop = (0, _utils.debounce)(this.didScrollStopSync, 200, this);
      this.wheelHandler = new _WheelHandler2.default(this.onScroll, this.shouldHandleWheelX, this.shouldHandleWheelY, this.props.stopScrollPropagation);

      this.touchHandler = new _TouchHandler2.default(this.onScroll, this.shouldHandleTouchX, this.shouldHandleTouchY, this.props.stopScrollPropagation);

      this.setNextState(this.calculateState(this.props));
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.reportContentHeight();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.ownerHeight !== nextProps.ownerHeight || this.props.scrollTop !== nextProps.scrollTop || this.props.scrollLeft !== nextProps.scrollLeft) {
        this.didScrollStart();
      }

      this.didScrollStop.reset();
      this.didScrollStopSync();

      this.setNextState(this.calculateState(nextProps, this.state));
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.reportContentHeight();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.wheelHandler = null;
      this.touchHandler = null;
      // cancel any pending debounced scroll handling and handle immediately
      this.didScrollStop.reset();
      this.didScrollStopSync();
    }
  }, {
    key: 'doHorizontalScroll',
    value: function doHorizontalScroll(scrollX, relative) {
      // eslint-disable-line
      var scrollState = relative ? this.horizontalScrollHelper.scrollBy(Math.round(scrollX)) : this.horizontalScrollHelper.scrollTo(Math.round(scrollX));

      var onHorizontalScroll = this.props.onHorizontalScroll;
      if (onHorizontalScroll) {
        onHorizontalScroll(scrollState.position);
      }

      var columnData = this.state.columnData;
      var contentWidth = columnData.leftFixedColumnsWidth + columnData.rightFixedColumnsWidth + scrollState.contentWidth;
      var maxScrollX = Math.max(0, contentWidth - this.state.bodyWidth);
      var scrollableColumnsToRender = this.columnBuffer.getColumns(scrollState.index, scrollState.offset);

      this.setNextState({
        firstColumnIndex: scrollState.index,
        firstColumnOffset: scrollState.offset,
        scrollX: scrollState.position,
        maxScrollX: maxScrollX,
        scrollableColumnsToRender: scrollableColumnsToRender
      });
    }
  }, {
    key: 'doVerticalScroll',
    value: function doVerticalScroll(scrollY, relative) {
      // eslint-disable-line
      var scrollState = relative ? this.verticalScrollHelper.scrollBy(Math.round(scrollY)) : this.verticalScrollHelper.scrollTo(Math.round(scrollY));

      var onVerticalScroll = this.props.onVerticalScroll;
      if (onVerticalScroll) {
        onVerticalScroll(scrollState.position);
      }

      var maxScrollY = Math.max(0, scrollState.contentHeight - this.state.bodyHeight);
      this.setNextState({
        firstRowIndex: scrollState.index,
        firstRowOffset: scrollState.offset,
        contentHeight: scrollState.contentHeight,
        scrollY: scrollState.position,
        maxScrollY: maxScrollY
      });
    }
  }, {
    key: 'didScrollStart',
    value: function didScrollStart() {
      // eslint-disable-line
      if (this.scrolling) {
        return;
      }

      this.scrolling = true;
      if (this.props.onScrollStart) {
        this.props.onScrollStart(this.state.scrollX, this.state.scrollY, this.state.firstRowIndex);
      }
    }
  }, {
    key: 'didScrollStopSync',
    value: function didScrollStopSync() {
      if (!this.scrolling) {
        return;
      }

      this.scrolling = false;
      this.setNextState({ redraw: true });
      if (this.props.onScrollEnd) {
        this.props.onScrollEnd(this.state.scrollX, this.state.scrollY, this.state.firstRowIndex);
      }
    }
  }, {
    key: 'reportContentHeight',
    value: function reportContentHeight() {
      var requiredHeight = this.state.contentHeight + this.state.reservedHeight;

      var contentHeight = void 0;
      if (this.state.useMaxHeight && this.props.maxHeight > requiredHeight) {
        contentHeight = requiredHeight;
      } else if (this.state.height > requiredHeight && this.props.ownerHeight) {
        contentHeight = Math.max(requiredHeight, this.props.ownerHeight);
      } else {
        contentHeight = this.state.height + this.state.maxScrollY;
      }

      if (contentHeight !== this.contentHeight && this.props.onContentHeightChange) {
        this.props.onContentHeightChange(contentHeight);
      }

      this.contentHeight = contentHeight;
    }
  }, {
    key: 'isColumnResizing',
    value: function isColumnResizing() {
      return this.state.columnResizingKey != null;
    }
  }, {
    key: 'isColumnReordering',
    value: function isColumnReordering() {
      return this.state.columnReorderingKey != null;
    }
  }, {
    key: 'setNextState',
    value: function setNextState(nextState) {
      var _this2 = this;

      var oldColumnData = this.state && this.state.columnData;
      var scrollableColumnsToRender = nextState.scrollableColumnsToRender,
          columnData = nextState.columnData;


      var leftFixedColumnsUpdated = false;
      var scrollableColumnsUpdated = false;
      var rightFixedColumnsUpdated = false;
      var scrollableColumnsToRenderUpdated = false;

      if (columnData && oldColumnData) {
        leftFixedColumnsUpdated = !(columnData.leftFixedColumns === oldColumnData.leftFixedColumns || (0, _utils.deepEqual)(columnData.leftFixedColumns, oldColumnData.leftFixedColumns));

        scrollableColumnsUpdated = !(columnData.scrollableColumns === oldColumnData.scrollableColumns || (0, _utils.deepEqual)(columnData.scrollableColumns, oldColumnData.scrollableColumns));

        rightFixedColumnsUpdated = !(columnData.rightFixedColumns === oldColumnData.rightFixedColumns || (0, _utils.deepEqual)(columnData.rightFixedColumns, oldColumnData.rightFixedColumns));
      } else if (columnData && !oldColumnData) {
        leftFixedColumnsUpdated = true;
        scrollableColumnsUpdated = true;
        rightFixedColumnsUpdated = true;
      }

      if (this.state) {
        scrollableColumnsToRenderUpdated = !(scrollableColumnsToRender === this.state.scrollableColumnsToRender || (0, _utils.deepEqual)(scrollableColumnsToRender, this.state.scrollableColumnsToRender));
      } else {
        scrollableColumnsToRenderUpdated = true;
      }

      var state = (0, _extends3.default)({}, nextState, {
        leftFixedColumnsUpdated: leftFixedColumnsUpdated,
        scrollableColumnsUpdated: scrollableColumnsUpdated,
        rightFixedColumnsUpdated: rightFixedColumnsUpdated,
        scrollableColumnsToRenderUpdated: scrollableColumnsToRenderUpdated
      });

      if (scrollableColumnsToRender) {
        var scrollableLeafColumns = columnData ? columnData.scrollableLeafColumns : oldColumnData.scrollableLeafColumns;

        var leafColumnsToRender = scrollableColumnsToRender.map(function (index) {
          return (0, _extends3.default)({}, scrollableLeafColumns[index], {
            offsetLeft: _this2.horizontalScrollHelper.getColumnPosition(index)
          });
        });
        var parents = leafColumnsToRender.map(function (item) {
          var result = item;
          var parent = item.parent;
          while (parent) {
            result = parent;
            parent = result.parent;
          }

          return result;
        });

        var columnsToRender = [];
        parents.forEach(function (item) {
          if (!columnsToRender.includes(item)) {
            columnsToRender.push(item);
          }
        });

        state.scrollableColumnsToRender = columnsToRender;
        state.scrollableLeafColumnsToRender = leafColumnsToRender;
      }

      this.setState(state);
    }
  }, {
    key: 'calculateState',
    value: function calculateState() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var oldState = arguments[1];

      (0, _invariant2.default)(props.height !== undefined || props.maxHeight !== undefined, 'Either height or maxHeight should be specified');

      var cachedColumnData = {
        widthMap: this.columnWidthMap || {},
        orderMap: this.columnOrderMap || {}
      };

      if (oldState) {
        cachedColumnData.resizingKey = oldState.columnResizingKey;
        cachedColumnData.reorderingKey = oldState.columnReorderingKey;
      }

      var columnData = (0, _FlexiGridColumnHelper.parseColumns)(props.columns, cachedColumnData);
      var rowCount = props.data.length;
      var rowHeight = props.rowHeight;
      var borderSize = props.bordered ? props.borderSize : 0;
      var reservedBorderSize = props.bordered ? 2 * borderSize : 0;
      var headerHeight = columnData.depth * rowHeight;
      var useMaxHeight = props.height === undefined;
      var realUseHeight = useMaxHeight ? props.maxHeight : props.height;

      // the size of viewport includes scrollbars
      var viewportWidth = props.width - reservedBorderSize;
      var viewportHeight = realUseHeight - (headerHeight || 0) - (props.footerHeight || 0) - reservedBorderSize;

      var firstRowIndex = oldState && oldState.firstRowIndex || 0;
      var firstRowOffset = oldState && oldState.firstRowOffset || 0;
      var firstColumnIndex = oldState && oldState.firstColumnIndex || 0;
      var firstColumnOffset = oldState && oldState.firstColumnOffset || 0;
      var scrollX = oldState ? oldState.scrollX : 0;
      var scrollY = oldState ? oldState.scrollY : 0;

      if (!this.verticalScrollHelper) {
        this.verticalScrollHelper = new _FlexiGridVerticalScrollHelper2.default(rowCount, props.rowHeight, viewportHeight, props.getRowHeight, props.subRowHeight, props.getSubRowHeight);
      }

      var oldViewportHeight = this.verticalScrollHelper.viewportHeight;

      if (oldState && (rowCount !== oldState.rowCount || props.rowHeight !== oldState.rowHeight || props.height !== oldState.height)) {
        this.verticalScrollHelper = new _FlexiGridVerticalScrollHelper2.default(rowCount, props.rowHeight, viewportHeight, props.getRowHeight, props.subRowHeight, props.getSubRowHeight);
        var scrollState = this.verticalScrollHelper.scrollToRow(firstRowIndex, firstRowOffset);
        scrollY = scrollState.position;
        firstRowIndex = scrollState.index;
        firstRowOffset = scrollState.offset;
      } else if (oldState) {
        if (props.getRowHeight !== oldState.getRowHeight) {
          this.verticalScrollHelper.setRowHeightGetter(props.getRowHeight);
        }
        if (props.getSubRowHeight !== oldState.getSubRowHeight) {
          this.verticalScrollHelper.setSubRowHeightGetter(props.getSubRowHeight);
        }
      }

      // scrollToRow
      var oldScrollToRow = oldState ? oldState.scrollToRow : undefined;
      if (props.scrollToRow !== undefined && (props.scrollToRow !== oldScrollToRow || viewportHeight !== oldViewportHeight)) {
        var _scrollState = this.verticalScrollHelper.scrollRowIntoView(props.scrollToRow);
        scrollY = _scrollState.position;
        firstRowIndex = _scrollState.index;
        firstRowOffset = _scrollState.offset;
      }

      // scrollTop
      var oldScrollTop = oldState ? oldState.scrollTop : undefined;
      if (props.scrollTop !== undefined && props.scrollTop !== oldScrollTop) {
        var _scrollState2 = this.verticalScrollHelper.scrollTo(props.scrollTop);
        scrollY = _scrollState2.position;
        firstRowIndex = _scrollState2.index;
        firstRowOffset = _scrollState2.offset;
      }

      // size for content
      var contentWidth = (0, _FlexiGridColumnHelper.getColumnsWidth)(columnData.columns);
      var contentHeight = this.verticalScrollHelper.getContentHeight();
      var showScrollbarX = contentWidth > viewportWidth + borderSize;
      var showScrollbarY = contentHeight > viewportHeight;
      var reservedHeight = props.footerHeight + headerHeight + reservedBorderSize + (showScrollbarX ? _Scrollbar2.default.SIZE : 0);
      var requiredHeight = contentHeight + reservedHeight;
      var reservedColumnWidth = columnData.leftFixedColumnsWidth + columnData.rightFixedColumnsWidth;

      var height = Math.round(realUseHeight);
      if (useMaxHeight && !showScrollbarY) {
        height = requiredHeight;
      }

      // body's size excludes scrollbars
      var bodyWidth = viewportWidth - (showScrollbarY ? _Scrollbar2.default.SIZE : 0);
      var bodyHeight = height - reservedHeight;

      var maxScrollX = Math.max(0, contentWidth - bodyWidth);
      var maxScrollY = Math.max(0, contentHeight - bodyHeight);
      scrollX = Math.min(scrollX, maxScrollX);
      scrollY = Math.min(scrollY, maxScrollY);

      this.verticalScrollHelper.setViewportHeight(bodyHeight);

      var getScrollableColumnWidth = function getScrollableColumnWidth(index) {
        return columnData.scrollableLeafColumns[index].width;
      };
      var scrollableViewportWidth = bodyWidth - reservedColumnWidth;
      if (!this.horizontalScrollHelper) {
        this.horizontalScrollHelper = new _FlexiGridHorizontalScrollHelper2.default(columnData.scrollableLeafColumns.length, scrollableViewportWidth, getScrollableColumnWidth);
      } else {
        this.horizontalScrollHelper.setViewportWidth(scrollableViewportWidth);
        this.horizontalScrollHelper.setColumnWidthGetter(getScrollableColumnWidth);
      }

      // scrollToColumn
      var oldScrollToColumn = oldState ? oldState.scrollToColumn : undefined;
      var scrollToColumn = props.scrollToColumn;
      if (scrollToColumn !== undefined && scrollToColumn !== oldScrollToColumn) {
        var leftFixedCount = columnData.leftFixedLeafColumns.length;
        var scrollableCount = columnData.scrollableLeafColumns.length;
        var columnIndex = (0, _utils.clamp)(scrollToColumn - leftFixedCount, 0, scrollableCount - 1);
        var _scrollState3 = this.horizontalScrollHelper.scrollToColumn(columnIndex);
        scrollX = _scrollState3.position;
        firstColumnIndex = _scrollState3.index;
        firstColumnOffset = _scrollState3.offset;
      }

      // scrollLeft
      var oldScrollLeft = oldState ? oldState.scrollLeft : undefined;
      if (props.scrollLeft !== undefined && props.scrollLeft !== oldScrollLeft) {
        var _scrollState4 = this.horizontalScrollHelper.scrollTo(props.scrollLeft);
        scrollX = _scrollState4.position;
        firstColumnIndex = _scrollState4.index;
        firstColumnOffset = _scrollState4.offset;
      }

      if (!this.columnBuffer || !oldState || !(0, _utils.deepEqual)(columnData.scrollableColumns, oldState.scrollableColumns)) {
        this.columnBuffer = new _FlexiGridColumnBuffer2.default(columnData.scrollableLeafColumns.length, scrollableViewportWidth, getScrollableColumnWidth, props.bufferColumnCount);
      }

      var scrollableColumnsToRender = this.columnBuffer.getColumns(firstColumnIndex, firstColumnOffset);

      // The order of elements in this object metters and bringing bodyHeight,
      // height or useGroupHeader to the top can break various features
      var newState = {
        rowCount: rowCount,

        columnData: columnData,
        scrollableColumnsToRender: scrollableColumnsToRender,
        columnResizingKey: oldState && oldState.columnResizingKey || null,
        columnReorderingKey: oldState && oldState.columnReorderingKey || null,

        height: height,
        rowHeight: rowHeight,
        useMaxHeight: useMaxHeight,
        headerHeight: headerHeight,
        reservedHeight: reservedHeight,

        viewportWidth: viewportWidth,
        viewportHeight: viewportHeight,

        bodyWidth: bodyWidth,
        bodyHeight: bodyHeight,

        contentWidth: contentWidth,
        contentHeight: contentHeight,

        firstRowIndex: firstRowIndex,
        firstRowOffset: firstRowOffset,
        firstColumnIndex: firstColumnIndex,
        firstColumnOffset: firstColumnOffset,
        scrollX: scrollX,
        scrollY: scrollY,
        maxScrollX: maxScrollX,
        maxScrollY: maxScrollY,
        showScrollbarX: showScrollbarX,
        showScrollbarY: showScrollbarY,

        // store these props for next compare
        scrollTop: props.scrollTop,
        scrollLeft: props.scrollLeft,
        scrollToRow: props.scrollToRow,
        scrollToColumn: props.scrollToColumn,
        getRowHeight: props.getRowHeight,
        getSubRowHeight: props.getSubRowHeight
      };

      return newState;
    }
  }, {
    key: 'getColumnReorderingData',
    value: function getColumnReorderingData() {
      var raw = this.columnReorderingData;
      if (raw) {
        var column = raw.column;
        var _props = this.props,
            prefixCls = _props.prefixCls,
            rowHeight = _props.rowHeight,
            borderSize = _props.borderSize,
            reorderFactor = _props.reorderFactor,
            reorderKnobSize = _props.reorderKnobSize;
        var _state = this.state,
            bodyWidth = _state.bodyWidth,
            headerHeight = _state.headerHeight,
            bodyHeight = _state.bodyHeight,
            columnData = _state.columnData,
            scrollX = _state.scrollX;
        var leftFixedColumnsWidth = columnData.leftFixedColumnsWidth,
            rightFixedColumnsWidth = columnData.rightFixedColumnsWidth;

        var maxRight = bodyWidth - rightFixedColumnsWidth;

        var offsetTop = (column.depth - 1) * rowHeight;

        var offsetLeft = column.left;
        if (this.state.showScrollbarX) {
          if (!column.fixed) {
            offsetLeft -= scrollX;
          } else if (column.fixed === 'right') {
            offsetLeft += bodyWidth - rightFixedColumnsWidth;
          }
        }

        var siblings = this.getColumnSiblings(column);
        var targets = [];
        var siblingLeft = offsetLeft;
        siblings.some(function (item) {
          if (item === column) {
            return true;
          }
          siblingLeft -= item.width;
          return false;
        });

        siblings.forEach(function (item) {
          targets.push({
            left: siblingLeft,
            top: offsetTop,
            height: headerHeight - offsetTop,
            width: item.width,
            key: item.key,
            leftSideVisible: siblingLeft >= leftFixedColumnsWidth,
            rightSideVisible: siblingLeft + item.width <= maxRight
          });
          siblingLeft += item.width;
        });

        return (0, _extends3.default)({}, raw, {
          prefixCls: prefixCls,
          width: bodyWidth,
          height: headerHeight + bodyHeight,
          offsetLeft: offsetLeft,
          offsetTop: offsetTop,
          targets: targets,
          rowHeight: rowHeight,
          columnHeight: headerHeight - offsetTop,
          borderSize: borderSize,
          scrollX: scrollX,
          factor: reorderFactor,
          knobSize: reorderKnobSize
        });
      }

      return raw;
    }
  }, {
    key: 'getColumnSiblings',
    value: function getColumnSiblings(column) {
      var siblings = column.depth > 1 ? column.parent.children : null;
      if (!siblings) {
        var columnData = this.state.columnData;
        if (column.fixed === 'left') {
          siblings = columnData.leftFixedColumns;
        } else if (column.fixed === 'right') {
          siblings = columnData.rightFixedColumns;
        } else {
          siblings = columnData.scrollableColumns;
        }
      }

      return siblings;
    }
  }, {
    key: 'getHeaderAndBodyCommonProps',
    value: function getHeaderAndBodyCommonProps() {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          rowHeight = _props2.rowHeight,
          bordered = _props2.bordered;
      var _state2 = this.state,
          columnData = _state2.columnData,
          scrollX = _state2.scrollX,
          showScrollbarX = _state2.showScrollbarX,
          showScrollbarY = _state2.showScrollbarY,
          scrollableColumnsToRender = _state2.scrollableColumnsToRender,
          scrollableLeafColumnsToRender = _state2.scrollableLeafColumnsToRender,
          leftFixedColumnsUpdated = _state2.leftFixedColumnsUpdated,
          scrollableColumnsUpdated = _state2.scrollableColumnsUpdated,
          rightFixedColumnsUpdated = _state2.rightFixedColumnsUpdated,
          scrollableColumnsToRenderUpdated = _state2.scrollableColumnsToRenderUpdated;
      var leftFixedColumns = columnData.leftFixedColumns,
          scrollableColumns = columnData.scrollableColumns,
          rightFixedColumns = columnData.rightFixedColumns,
          leftFixedLeafColumns = columnData.leftFixedLeafColumns,
          scrollableLeafColumns = columnData.scrollableLeafColumns,
          rightFixedLeafColumns = columnData.rightFixedLeafColumns,
          leftFixedColumnsWidth = columnData.leftFixedColumnsWidth,
          scrollableColumnsWidth = columnData.scrollableColumnsWidth,
          rightFixedColumnsWidth = columnData.rightFixedColumnsWidth;


      return {
        prefixCls: prefixCls,
        rowHeight: rowHeight,
        bordered: bordered,
        scrollX: scrollX,
        showScrollbarX: showScrollbarX,
        showScrollbarY: showScrollbarY,

        leftFixedColumns: leftFixedColumns,
        scrollableColumns: scrollableColumns,
        rightFixedColumns: rightFixedColumns,
        leftFixedLeafColumns: leftFixedLeafColumns,
        scrollableLeafColumns: scrollableLeafColumns,
        rightFixedLeafColumns: rightFixedLeafColumns,
        scrollableColumnsToRender: scrollableColumnsToRender,
        scrollableLeafColumnsToRender: scrollableLeafColumnsToRender,
        leftFixedColumnsWidth: leftFixedColumnsWidth,
        scrollableColumnsWidth: scrollableColumnsWidth,
        rightFixedColumnsWidth: rightFixedColumnsWidth,
        leftFixedColumnsUpdated: leftFixedColumnsUpdated,
        scrollableColumnsUpdated: scrollableColumnsUpdated,
        rightFixedColumnsUpdated: rightFixedColumnsUpdated,
        scrollableColumnsToRenderUpdated: scrollableColumnsToRenderUpdated
      };
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var _state3 = this.state,
          viewportWidth = _state3.viewportWidth,
          headerHeight = _state3.headerHeight;

      var props = (0, _extends3.default)({}, this.getHeaderAndBodyCommonProps(), {
        scrollbarSize: _Scrollbar2.default.SIZE,
        width: viewportWidth,
        height: headerHeight
      });
      return _react2.default.createElement(_FlexiGridHeader2.default, props);
    }
  }, {
    key: 'renderBody',
    value: function renderBody() {
      var props = (0, _extends3.default)({}, this.getHeaderAndBodyCommonProps(), {

        width: this.state.bodyWidth,
        height: this.state.bodyHeight,
        firstRowIndex: this.state.firstRowIndex,
        firstRowOffset: this.state.firstRowOffset,

        data: this.props.data,
        rowKey: this.props.rowKey,
        scrolling: this.scrolling,
        subRow: this.props.subRow,
        bufferRowCount: this.props.bufferRowCount,
        getRowPosition: this.verticalScrollHelper.getRowPosition,
        getRowHeight: this.props.getRowHeight,
        getSubRowHeight: this.props.getSubRowHeight,
        getRowClassName: this.props.getRowClassName,

        onRowClick: this.props.onRowClick,
        onRowDoubleClick: this.props.onRowDoubleClick,
        onRowMouseDown: this.props.onRowMouseDown,
        onRowMouseUp: this.props.onRowMouseUp,
        onRowMouseEnter: this.props.onRowMouseEnter,
        onRowMouseLeave: this.props.onRowMouseLeave,

        onRowTouchStart: this.props.onRowTouchStart,
        onRowTouchEnd: this.props.onRowTouchEnd,
        onRowTouchMove: this.props.onRowTouchMove
      });
      return _react2.default.createElement(_FlexiGridBody2.default, props);
    }
  }, {
    key: 'renderFooter',
    value: function renderFooter() {
      var _props3 = this.props,
          prefixCls = _props3.prefixCls,
          footerHeight = _props3.footerHeight,
          footer = _props3.footer;
      var viewportWidth = this.state.viewportWidth;

      var style = {
        width: viewportWidth,
        height: footerHeight
      };

      return _react2.default.createElement(
        'div',
        {
          className: prefixCls + '-footer',
          style: style
        },
        footer
      );
    }
  }, {
    key: 'renderShadowTop',
    value: function renderShadowTop() {
      var props = {
        prefixCls: this.props.prefixCls,
        display: this.state.showScrollbarY,
        visible: this.state.scrollY > 0,
        width: this.state.bodyWidth,
        top: this.state.headerHeight
      };

      return _react2.default.createElement(_FlexiGridShadowTop2.default, props);
    }
  }, {
    key: 'renderShadowBottom',
    value: function renderShadowBottom() {
      var props = {
        prefixCls: this.props.prefixCls,
        display: this.state.showScrollbarY,
        visible: this.state.scrollY !== this.state.maxScrollY,
        width: this.state.bodyWidth,
        bottom: this.props.footerHeight
      };

      return _react2.default.createElement(_FlexiGridShadowBottom2.default, props);
    }
  }, {
    key: 'renderShadowLeft',
    value: function renderShadowLeft() {
      var _state$columnData = this.state.columnData,
          leftFixedColumns = _state$columnData.leftFixedColumns,
          leftFixedColumnsWidth = _state$columnData.leftFixedColumnsWidth;

      var props = {
        prefixCls: this.props.prefixCls,
        display: leftFixedColumns.length > 0,
        visible: this.state.scrollX > 0,
        height: this.state.headerHeight + this.state.bodyHeight,
        left: leftFixedColumnsWidth
      };

      return _react2.default.createElement(_FlexiGridShadowLeft2.default, props);
    }
  }, {
    key: 'renderShadowRight',
    value: function renderShadowRight() {
      var _state$columnData2 = this.state.columnData,
          rightFixedColumns = _state$columnData2.rightFixedColumns,
          rightFixedColumnsWidth = _state$columnData2.rightFixedColumnsWidth;

      var props = {
        prefixCls: this.props.prefixCls,
        display: rightFixedColumns.length > 0,
        visible: this.state.scrollX !== this.state.maxScrollX,
        height: this.state.headerHeight + this.state.bodyHeight,
        right: rightFixedColumnsWidth + (this.state.showScrollbarY ? _Scrollbar2.default.SIZE : 0)
      };

      return _react2.default.createElement(_FlexiGridShadowRight2.default, props);
    }
  }, {
    key: 'renderResizeKnobs',
    value: function renderResizeKnobs() {
      var columnData = this.state.columnData;


      var props = {
        prefixCls: this.props.prefixCls,
        knobSize: this.props.resizeKnobSize,
        rowHeight: this.props.rowHeight,
        headerHeight: this.state.headerHeight,
        bodyHeight: this.state.bodyHeight,
        bodyWidth: this.state.bodyWidth,
        scrollX: this.state.scrollX,
        showScrollbarX: this.state.showScrollbarX,
        leftFixedLeafColumns: columnData.leftFixedLeafColumns,
        scrollableLeafColumns: columnData.scrollableLeafColumns,
        rightFixedLeafColumns: columnData.rightFixedLeafColumns,
        leftFixedColumnsWidth: columnData.leftFixedColumnsWidth,
        scrollableColumnsWidth: columnData.scrollableColumnsWidth,
        rightFixedColumnsWidth: columnData.rightFixedColumnsWidth,
        onColumnResize: this.onColumnResize
      };

      return _react2.default.createElement(_FlexiGridColumnResizeKnobs2.default, props);
    }
  }, {
    key: 'renderColumnResizeHandler',
    value: function renderColumnResizeHandler() {
      var props = this.columnResizingData || { prefixCls: this.props.prefixCls };
      return _react2.default.createElement(_FlexiGridColumnResizeHandler2.default, (0, _extends3.default)({}, props, { visible: this.isColumnResizing() }));
    }
  }, {
    key: 'renderReorderKnobs',
    value: function renderReorderKnobs() {
      var columnData = this.state.columnData;


      var props = {
        prefixCls: this.props.prefixCls,
        knobSize: this.props.reorderKnobSize,
        rowHeight: this.props.rowHeight,
        headerHeight: this.state.headerHeight,
        bodyWidth: this.state.bodyWidth,
        scrollX: this.state.scrollX,
        showScrollbarX: this.state.showScrollbarX,
        leftFixedColumns: columnData.leftFixedColumns,
        scrollableColumns: columnData.scrollableColumns,
        rightFixedColumns: columnData.rightFixedColumns,
        leftFixedColumnsWidth: columnData.leftFixedColumnsWidth,
        scrollableColumnsWidth: columnData.scrollableColumnsWidth,
        rightFixedColumnsWidth: columnData.rightFixedColumnsWidth,
        onColumnReorder: this.onColumnReorder
      };

      return _react2.default.createElement(_FlexiGridColumnReorderKnobs2.default, props);
    }
  }, {
    key: 'renderColumnReorderHandler',
    value: function renderColumnReorderHandler() {
      var props = this.getColumnReorderingData() || { prefixCls: this.props.prefixCls };
      return _react2.default.createElement(_FlexiGridColumnReorderHandler2.default, (0, _extends3.default)({}, props, {
        visible: this.isColumnReordering()
      }));
    }
  }, {
    key: 'renderScrollbar',
    value: function renderScrollbar() {
      var state = this.state;
      var props = this.props;
      var result = {};

      if (state.showScrollbarY) {
        result.verticalScrollbar = _react2.default.createElement(_Scrollbar2.default, {
          orientation: 'vertical',
          top: state.headerHeight,
          prefixCls: props.prefixCls,
          position: state.scrollY,
          size: state.bodyHeight,
          contentSize: state.contentHeight,
          onScroll: this.onVerticalScroll
        });
      }

      if (state.showScrollbarX) {
        result.horizontalScrollbar = _react2.default.createElement(_Scrollbar2.default, {
          orientation: 'horizontal',
          prefixCls: props.prefixCls,
          position: state.scrollX,
          size: state.bodyWidth,
          contentSize: state.contentWidth,
          hasVerticalScrollbar: state.showScrollbarX,
          onScroll: this.onHorizontalScroll
        });
      }

      return result;
    }
  }, {
    key: 'render',
    value: function render() {
      var state = this.state;
      var props = this.props;

      var prefixCls = props.prefixCls,
          className = props.className,
          bordered = props.bordered,
          reorderable = props.reorderable;

      var mainClassNames = (0, _classnames2.default)(prefixCls, className, { bordered: bordered, reorderable: reorderable });

      var _renderScrollbar = this.renderScrollbar(),
          verticalScrollbar = _renderScrollbar.verticalScrollbar,
          horizontalScrollbar = _renderScrollbar.horizontalScrollbar;

      return _react2.default.createElement(
        'div',
        {
          className: mainClassNames,
          onWheel: this.wheelHandler.onWheel,
          onTouchStart: this.touchHandler.onTouchStart,
          onTouchEnd: this.touchHandler.onTouchEnd,
          onTouchMove: this.touchHandler.onTouchMove,
          onTouchCancel: this.touchHandler.onTouchCancel,
          style: { width: state.width, height: state.height }
        },
        _react2.default.createElement(
          'div',
          {
            className: prefixCls + '-container',
            style: {
              width: state.viewportWidth,
              height: state.headerHeight + state.bodyHeight + props.footerHeight
            }
          },
          this.renderHeader(),
          this.renderBody(),
          this.renderFooter(),
          this.renderShadowTop(),
          this.renderShadowRight(),
          this.renderShadowBottom(),
          this.renderShadowLeft(),
          this.props.resizeable && this.renderResizeKnobs(),
          this.props.reorderable && this.renderReorderKnobs(),
          this.props.resizeable && this.renderColumnResizeHandler(),
          this.props.reorderable && this.renderColumnReorderHandler()
        ),
        verticalScrollbar,
        horizontalScrollbar
      );
    }
  }]);
  return FlexiGrid;
}(_react2.default.Component); /* eslint-disable react/require-default-props */

FlexiGrid.propTypes = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes2.default.string,

  columns: _propTypes4.default.columns.isRequired,
  data: _propTypes4.default.data.isRequired,
  rowKey: _propTypes2.default.string.isRequired,
  bufferRowCount: _propTypes2.default.number,
  bufferColumnCount: _propTypes2.default.number,

  bordered: _propTypes2.default.bool,
  borderSize: _propTypes2.default.number,

  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number,
  maxHeight: _propTypes2.default.number,
  ownerHeight: _propTypes2.default.number,
  footerHeight: _propTypes2.default.number,
  rowHeight: _propTypes2.default.number.isRequired,
  subRowHeight: _propTypes2.default.number,

  getRowHeight: _propTypes2.default.func,
  getSubRowHeight: _propTypes2.default.func,
  getRowClassName: _propTypes2.default.func,

  subRow: _propTypes4.default.render,
  footer: _propTypes4.default.render,

  scrollTop: _propTypes2.default.number,
  scrollLeft: _propTypes2.default.number,
  scrollToColumn: _propTypes2.default.number,
  scrollToRow: _propTypes2.default.number,
  showScrollbarX: _propTypes2.default.bool,
  showScrollbarY: _propTypes2.default.bool,
  touchScrollEnabled: _propTypes2.default.bool,

  onHorizontalScroll: _propTypes2.default.func,
  onVerticalScroll: _propTypes2.default.func,
  onScrollStart: _propTypes2.default.func,
  onScrollEnd: _propTypes2.default.func,
  stopScrollPropagation: _propTypes2.default.bool,

  onContentHeightChange: _propTypes2.default.func,

  onRowTouchStart: _propTypes2.default.func,
  onRowTouchEnd: _propTypes2.default.func,
  onRowTouchMove: _propTypes2.default.func,

  onRowClick: _propTypes2.default.func,
  onRowDoubleClick: _propTypes2.default.func,
  onRowMouseDown: _propTypes2.default.func,
  onRowMouseUp: _propTypes2.default.func,
  onRowMouseEnter: _propTypes2.default.func,
  onRowMouseLeave: _propTypes2.default.func,

  resizeable: _propTypes2.default.bool,
  resizeKnobSize: _propTypes2.default.number,
  onColumnResize: _propTypes2.default.func,
  onColumnResizing: _propTypes2.default.func,
  onColumnResized: _propTypes2.default.func,

  reorderable: _propTypes2.default.bool,
  reorderKnobSize: _propTypes2.default.number,
  reorderFactor: _propTypes2.default.number,
  dragScrollBuffer: _propTypes2.default.number,
  dragScrollSpeed: _propTypes2.default.number,
  onColumnReorder: _propTypes2.default.func,
  onColumnReordering: _propTypes2.default.func,
  onColumnReordered: _propTypes2.default.func
};
FlexiGrid.defaultProps = {
  prefixCls: 'flexi-grid',
  rowHeight: 32,
  subRowHeight: 0,
  footerHeight: 0,
  bordered: true,
  borderSize: 1,
  showScrollbarX: true,
  showScrollbarY: true,
  touchScrollEnabled: false,
  stopScrollPropagation: false,

  resizeable: false,
  resizeKnobSize: 13,

  reorderable: false,
  reorderKnobSize: 12,
  reorderFactor: 3 / 4,
  dragScrollBuffer: 50,
  dragScrollSpeed: 15
};
exports.default = FlexiGrid;
module.exports = exports['default'];