'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridColumnReorderKnobs = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridColumnReorderKnobs, _React$Component);

  function FlexiGridColumnReorderKnobs() {
    (0, _classCallCheck3.default)(this, FlexiGridColumnReorderKnobs);
    return (0, _possibleConstructorReturn3.default)(this, (FlexiGridColumnReorderKnobs.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridColumnReorderKnobs)).apply(this, arguments));
  }

  (0, _createClass3.default)(FlexiGridColumnReorderKnobs, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _utils.shallowEqual)(this.props, nextProps);
    }
  }, {
    key: 'buildReorderKnob',
    value: function buildReorderKnob(column, leftColumnsWidth, scrollable, isRightFixedColumn) {
      var _this2 = this;

      if (column.reorderable === false) {
        return null;
      }

      var _props = this.props,
          knobSize = _props.knobSize,
          rowHeight = _props.rowHeight,
          headerHeight = _props.headerHeight,
          bodyWidth = _props.bodyWidth,
          scrollX = _props.scrollX,
          showScrollbarX = _props.showScrollbarX,
          leftFixedColumnsWidth = _props.leftFixedColumnsWidth,
          scrollableColumnsWidth = _props.scrollableColumnsWidth,
          rightFixedColumnsWidth = _props.rightFixedColumnsWidth;


      var hasChildren = column.children && column.children.length > 0;
      var top = rowHeight * (column.depth - 1);
      var left = leftColumnsWidth - (scrollable ? scrollX : 0);
      var height = (hasChildren ? rowHeight : headerHeight - top) - 1;

      var style = {
        top: top,
        left: left,
        width: knobSize,
        height: height,
        zIndex: scrollable ? 0 : 1
      };

      var data = {
        column: column,
        knobSize: knobSize
      };

      if (showScrollbarX) {
        if (scrollable) {
          if (left < leftFixedColumnsWidth || left > bodyWidth - rightFixedColumnsWidth - knobSize) {
            style.display = 'none';
          }
        }

        if (isRightFixedColumn) {
          style.left = bodyWidth - leftFixedColumnsWidth - rightFixedColumnsWidth + (leftColumnsWidth - scrollableColumnsWidth);
        }
      }

      var key = column.key || leftColumnsWidth + '-' + column.depth;

      return _react2.default.createElement('div', { // eslint-disable-line
        key: 'reorder-knob-for-' + key,
        className: this.props.prefixCls + '-reorder-knob',
        style: style,
        onMouseDown: function onMouseDown(e) {
          _this2.props.onColumnReorder(data, e);
        }
      });
    }
  }, {
    key: 'buildReorderKnobs',
    value: function buildReorderKnobs(columns, leftColumnsWidth, scrollable, isRightFixed) {
      var _this3 = this;

      var width = leftColumnsWidth;
      var knobs = [];

      columns.forEach(function (column) {
        knobs.push(_this3.buildReorderKnob(column, width, scrollable, isRightFixed));
        if (column.children && column.children.length) {
          knobs.push.apply(knobs, (0, _toConsumableArray3.default)(_this3.buildReorderKnobs(column.children, width, scrollable, isRightFixed)));
        }
        width += column.width;
      });

      return knobs;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          leftFixedColumns = _props2.leftFixedColumns,
          scrollableColumns = _props2.scrollableColumns,
          rightFixedColumns = _props2.rightFixedColumns,
          leftFixedColumnsWidth = _props2.leftFixedColumnsWidth,
          scrollableColumnsWidth = _props2.scrollableColumnsWidth;

      var knobs = [].concat((0, _toConsumableArray3.default)(this.buildReorderKnobs(leftFixedColumns, 0, false, false)), (0, _toConsumableArray3.default)(this.buildReorderKnobs(scrollableColumns, leftFixedColumnsWidth, true, false)), (0, _toConsumableArray3.default)(this.buildReorderKnobs(rightFixedColumns, leftFixedColumnsWidth + scrollableColumnsWidth, false, true)));

      return _react2.default.createElement(
        'div',
        { className: this.props.prefixCls + '-reorder-wrap' },
        knobs
      );
    }
  }]);
  return FlexiGridColumnReorderKnobs;
}(_react2.default.Component);

FlexiGridColumnReorderKnobs.propTypes = {
  prefixCls: _propTypes2.default.string.isRequired,
  knobSize: _propTypes2.default.number.isRequired,
  rowHeight: _propTypes2.default.number.isRequired,
  headerHeight: _propTypes2.default.number.isRequired,
  bodyWidth: _propTypes2.default.number.isRequired,
  scrollX: _propTypes2.default.number.isRequired,
  showScrollbarX: _propTypes2.default.bool.isRequired,
  leftFixedColumns: _propTypes4.default.columns.isRequired,
  scrollableColumns: _propTypes4.default.columns.isRequired,
  rightFixedColumns: _propTypes4.default.columns.isRequired,
  leftFixedColumnsWidth: _propTypes2.default.number.isRequired,
  scrollableColumnsWidth: _propTypes2.default.number.isRequired,
  rightFixedColumnsWidth: _propTypes2.default.number.isRequired,
  onColumnReorder: _propTypes2.default.func.isRequired
};
exports.default = FlexiGridColumnReorderKnobs;
module.exports = exports['default'];