'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridColumnResizeKnobs = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridColumnResizeKnobs, _React$Component);

  function FlexiGridColumnResizeKnobs() {
    (0, _classCallCheck3.default)(this, FlexiGridColumnResizeKnobs);
    return (0, _possibleConstructorReturn3.default)(this, (FlexiGridColumnResizeKnobs.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridColumnResizeKnobs)).apply(this, arguments));
  }

  (0, _createClass3.default)(FlexiGridColumnResizeKnobs, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _utils.shallowEqual)(this.props, nextProps);
    }
  }, {
    key: 'renderResizeKnob',
    value: function renderResizeKnob(column, leftColumnsWidth, scrollable, isRightFixed) {
      var _this2 = this;

      if (column.resizeable === false) {
        return null;
      }

      var _props = this.props,
          rowHeight = _props.rowHeight,
          headerHeight = _props.headerHeight,
          bodyHeight = _props.bodyHeight,
          bodyWidth = _props.bodyWidth,
          scrollX = _props.scrollX,
          showScrollbarX = _props.showScrollbarX,
          leftFixedColumnsWidth = _props.leftFixedColumnsWidth,
          scrollableColumnsWidth = _props.scrollableColumnsWidth,
          rightFixedColumnsWidth = _props.rightFixedColumnsWidth;


      var knobSize = this.props.knobSize % 2 === 1 ? this.props.knobSize : this.props.knobSize + 1;

      var offsetLeft = leftColumnsWidth - (scrollable ? scrollX : 0);
      var left = offsetLeft - Math.ceil(knobSize / 2);
      var top = column.isFirstLeaf && isRightFixed || column.isLastLeaf ? 0 : rowHeight * (column.depth - 1);

      var style = {
        top: top,
        left: left,
        width: knobSize,
        height: headerHeight + bodyHeight - top,
        zIndex: scrollable ? 0 : 1
      };

      var data = {
        column: column,
        knobSize: knobSize,
        top: top,
        left: leftColumnsWidth - column.width - (scrollable ? scrollX : 0)
      };

      if (showScrollbarX) {
        if (scrollable) {
          if (offsetLeft <= leftFixedColumnsWidth || offsetLeft > bodyWidth - rightFixedColumnsWidth) {
            style.display = 'none';
          }

          // When the last scrollable column reach maxScrollX
          if (column.isLastLeaf && offsetLeft === bodyWidth - rightFixedColumnsWidth) {
            style.left -= knobSize;
            // Adjust the last scrollable column's resize-knob position when
            // reach the maxScrollX to avoid non-interactive.
            data.adjustKnob = true;
          }
        }

        if (isRightFixed) {
          data.left = bodyWidth - leftFixedColumnsWidth - rightFixedColumnsWidth + (leftColumnsWidth - scrollableColumnsWidth) - column.width;
          data.rtl = true;
          style.left = data.left - Math.ceil(knobSize / 2);
        }
      }

      return _react2.default.createElement(
        'div',
        { // eslint-disable-line
          key: column.key,
          style: style,
          className: this.props.prefixCls + '-resize-knob',
          onMouseDown: function onMouseDown(e) {
            _this2.props.onColumnResize(data, e);
          }
        },
        _react2.default.createElement('div', {
          className: this.props.prefixCls + '-resize-knob-marker',
          style: { left: Math.floor(knobSize / 2) }
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          leftFixedLeafColumns = _props2.leftFixedLeafColumns,
          scrollableLeafColumns = _props2.scrollableLeafColumns,
          rightFixedLeafColumns = _props2.rightFixedLeafColumns;

      var width = 0;
      return _react2.default.createElement(
        'div',
        { className: this.props.prefixCls + '-resize-wrap' },
        leftFixedLeafColumns.map(function (column) {
          width += column.width;
          return _this3.renderResizeKnob(column, width, false);
        }),
        scrollableLeafColumns.map(function (column) {
          width += column.width;
          return _this3.renderResizeKnob(column, width, true);
        }),
        rightFixedLeafColumns.map(function (column) {
          width += column.width;
          return _this3.renderResizeKnob(column, width, false, true);
        })
      );
    }
  }]);
  return FlexiGridColumnResizeKnobs;
}(_react2.default.Component);

FlexiGridColumnResizeKnobs.propTypes = {
  prefixCls: _propTypes2.default.string.isRequired,
  rowHeight: _propTypes2.default.number.isRequired,
  headerHeight: _propTypes2.default.number.isRequired,
  bodyHeight: _propTypes2.default.number.isRequired,
  bodyWidth: _propTypes2.default.number.isRequired,
  knobSize: _propTypes2.default.number.isRequired,
  scrollX: _propTypes2.default.number.isRequired,
  showScrollbarX: _propTypes2.default.bool.isRequired,
  leftFixedLeafColumns: _propTypes4.default.columns.isRequired,
  scrollableLeafColumns: _propTypes4.default.columns.isRequired,
  rightFixedLeafColumns: _propTypes4.default.columns.isRequired,
  leftFixedColumnsWidth: _propTypes2.default.number.isRequired,
  scrollableColumnsWidth: _propTypes2.default.number.isRequired,
  rightFixedColumnsWidth: _propTypes2.default.number.isRequired,
  onColumnResize: _propTypes2.default.func.isRequired
};
exports.default = FlexiGridColumnResizeKnobs;
module.exports = exports['default'];